=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/Vitis-AI-$1.tar.gz/,dversionmangle=s/\+dfsg// \
       https://github.com/Xilinx/XRT/tags .*/v?(\d\S*)\.tar\.gz
